<?php

namespace App\Http\Controllers\HR;

use App\Fun\Fun;
use App\HrJobExpLevelModel;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Yajra\DataTables\DataTables;

class HrJobExpLevelController extends Controller
{
    function __construct()
    {
         $this->middleware('permission:Experience-Level-List');
         $this->middleware('permission:Experience-Level-Create', ['only' => ['create','store']]);
         $this->middleware('permission:Experience-Level-Edit', ['only' => ['edit','update']]);
    }
    public function index()
    {
        return view('hr.job-exp-level.index');
    }
    public function get_exp_level()
    {
        $data = HrJobExpLevelModel::get();
        return DataTables::of($data)
            ->addIndexColumn()
            ->addColumn('action', function ($data) {
                $check_language = Fun::lang();
                if ($check_language == 'km') {
                    $edit = "កែសម្រួល";
                } else {
                    $edit = "Edit";
                }
                if(Gate::check('Experience-Level-Edit')){
                    return '<a href="'.route('hr-exp-level.edit',encrypt($data->id)).'" class="button_warning">'.$edit.'</a>';
                }
                return '';
            })

            ->rawColumns(['action' => 'action'])
            ->make(true);
    }

    public function create()
    {
        return view('hr.job-exp-level.create');
    }

    public function store(Request $request)
    {
        $this->validate($request,[
            'name'=>'required',
        ]);
        $ben = new HrJobExpLevelModel();
        $ben->name = $request->name;
        $ben->note = $request->note;
        $ben->save();
        return redirect()->route('hr-exp-level.index')->with('success','Experience level was inserted successful...');
    }

    public function show($id)
    {
        //
    }

    public function edit($id)
    {
        $ben = HrJobExpLevelModel::find(decrypt($id));
        return view('hr.job-exp-level.edit',compact('ben'));
    }

    public function update(Request $request, $id)
    {
        $this->validate($request,[
            'name'=>'required',
        ]);
        $ben = HrJobExpLevelModel::find($id);
        $ben->name = $request->name;
        $ben->note = $request->note;
        $ben->update();
        return redirect()->route('hr-exp-level.index')->with('success','Experience level was updated successful...');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}
